
/* RTF Macintosh character set (\mac) general map
 *
 * Field 1 is the standard character name which the character value in
 * field 2 maps onto.  (It doesn't mean "to produce the character in field 1,
 * use the value in field 2.)
 *
 * The character value may be given either as a single character (which will be
 * converted to the ASCII value of the character), or in numeric format, either
 * in decimal or 0xyy as hex yy.  Single or double quotes may be used to quote
 * characters.
 *
 * characters in ASCII range (00-127)
 *
 * http://perso.wanadoo.fr/blq
 * blq@wanadoo.fr
 */


typedef struct ansi_mac_gen {
	char * token;		/* token du code hexa identifie */
	char * hexa;
} AnsiMacGen;

AnsiMacGen ansiMacG [] = {
/*  characters in ASCII range (00-127) */

	"formula",			"06",
	"nobrkhyphen",		"1e",
	"opthyphen",		"1f",

	"space",			" ",
	"exclam",			"!",
	"quotedbl",			"\"",
	"numbersign",		"#",
	"dollar",			"$",
	"percent",			"%",
	"ampersand",		"&",
	"quoteright",		"'",
	"parenleft",		"(",
	"parenright",		")",
	"asterisk",			"*",
	"plus",				"+",
	"comma",			",",
	"hyphen",			"-",
	"period",			".",
	"slash",			"/",
	"zero",				"0",
	"one",				"1",
	"two",				"2",
	"three",			"3",
	"four",				"4",
	"five",				"5",
	"six",				"6",
	"seven",			"7",
	"eight",			"8",
	"nine",				"9",
	"colon",			":",
	"semicolon",		";",
	"less",				"<",
	"equal",			"=",
	"greater",			">",
	"question",			"?",
	"at",				"@",
	"A",				"A",
	"B",				"B",
	"C",				"C",
	"D",				"D",
	"E",				"E",
	"F",				"F",
	"G",				"G",
	"H",				"H",
	"I",				"I",
	"J",				"J",
	"K",				"K",
	"L",				"L",
	"M",				"M",
	"N",				"N",
	"O",				"O",
	"P",				"P",
	"Q",				"Q",
	"R",				"R",
	"S",				"S",
	"T",				"T",
	"U",				"U",
	"V",				"V",
	"W",				"W",
	"X",				"X",
	"Y",				"Y",
	"Z",				"Z",
	"bracketleft",		"[",
	"backslash",		"\\",
	"bracketright",		"]",
	"asciicircum",		"^",
	"underscore",		"_",
/*	"quoteleft",		"`"	*/
	"a",				"a",
	"b",				"b",
	"c",				"c",
	"d",				"d",
	"e",				"e",
	"f",				"f",
	"g",				"g",
	"h",				"h",
	"i",				"i",
	"j",				"j",
	"k",				"k",
	"l",				"l",
	"m",				"m",
	"n",				"n",
	"o",				"o",
	"p",				"p",
	"q",				"q",
	"r",				"r",
	"s",				"s",
	"t",				"t",
	"u",				"u",
	"v",				"v",
	"w",				"w",
	"x",				"x",
	"y",				"y",
	"z",				"z",
	"braceleft",		"{",
	"bar",				"|",
	"braceright",		"}",
	"asciitilde",		"~",

/* non-ASCII characters (128-255)*/

	"Adieresis",		"80",
	"Aring",			"81",
	"Ccedilla",			"82",
	"Eacute",			"83",
	"Ntilde",			"84",
	"Odieresis",		"85",
	"Udieresis",		"86",
	"aacute",			"87",
	"agrave",			"88",
	"acircumflex",		"89",
	"adieresis",		"8a",
	"atilde",			"8b",
	"aring",			"8c",
	"ccedilla",			"8d",
	"eacute",			"8e",
	"egrave",			"8f",
	"ecircumflex",		"90",
	"edieresis",		"91",
	"iacute",			"92",
	"igrave",			"93",
	"icircumflex",		"94",
	"idieresis",		"95",
	"ntilde",			"96",
	"oacute",			"97",
	"ograve",			"98",
	"ocircumflex",		"99",
	"odieresis",		"9a",
	"otilde",			"9b",
	"uacute",			"9c",
	"ugrave",			"9d",
	"ucircumflex",		"9e",
	"udieresis",		"9f",
	"dagger",			"a0",
	"degree",			"a1",
	"cent",				"a2",
	"sterling",			"a3",
	"chapitre",			"a4",
	"bullet",			"a5",
	"paragraph",		"a6",
	"germandbls",		"a7",
	"registered",		"a8",
	"copyright",		"a9",
	"trademark",		"aa",
	"acute",			"ab",
	"dieresis",			"ac",
	"notequal",			"ad",
	"AE",				"ae",
	"Oslash",			"af",
	"infinity",			"b0",
	"plusminus",		"b1",
	"lessequal",		"b2",
	"greaterequal",		"b3",
	"yen",				"b4",
	"mu",				"b5",
	"partialdiff",		"b6",
	"Sigma",			"b7",
	"Pi",				"b8",
	"pi",				"b9",
	"integral",			"ba",
	"ordfeminine",		"bb",
	"ordmasculine",		"bc",
	"Omega",			"bd",
	"ae",				"be",
	"oslash",			"bf",
	"questiondown",		"c0",
	"exclamdown",		"c1",
	"logicalnot",		"c2",
	"radical",			"c3",
	"florin",			"c4",
	"approxequal",		"c5",
	"Delta",			"c6",
	"guillemotleft",	"c7",
	"guillemotright",	"c8",
	"ellipsis",			"c9",
	"nobrkspace",		"ca",
	"Agrave",			"cb",
	"OE",				"ce",
	"oe",				"cf",
	"endash",			"d0",
	"emdash",			"d1",
	"quotedblleft",		"d2",
	"quotedblright",	"d3",
	"quoteleft",		"d4",
	"quoteright",		"d5",
	"divide",			"d6",
	"lozenge",			"d7",
	"ydieresis",		"d8",
	"Ydieresis",		"d9",
	"fraction",			"da",
	"currency",			"db",
	"guilsinglleft",	"dc",
	"guilsinglright",	"dd",
	"fi",				"de",
	"fl",				"df",
	"daggerdbl",		"e0",
	"periodcentered",	"e1",
	"quotesinglbase",	"e2",
	"quotedblbase",		"e3",
	"perthousand",		"e4",
	"Acircumflex",		"e5",
	"Ecircumflex",		"e6",
	"Aacute",			"e7",
	"Edieresis",		"e8",
	"Egrave",			"e9",
	"Iacute",			"ea",
	"Icircumflex",		"eb",
	"Idieresis",		"ec",
	"Igrave",			"ed",
	"Oacute",			"ee",
	"Ocircumflex",		"ef",
	"apple",			"f0",
	"Ograve",			"f1",
	"Uacute",			"f2",
	"Ucircumflex",		"f3",
	"Ugrave",			"f4",
	"dotlessi",			"f5",
	"circumflex",		"f6",
	"tilde",			"f7",
	"macron",			"f8",
	"breve",			"f9",
	"dotaccent",		"fa",
	"ring",				"fb",
	"cedilla",			"fc",
	"hungarumlaut",		"fd",
	"ogonek",			"fe",
	"caron",			"ff",

	(char *)0,			(char *)0
};

