
/*  RTF ANSI character set (\ansi) general map
 *  These are taken from the ISO-Latin-1 (ISO-8859-1) encodings, with 
 *  a few additions
 * 
 *  Field 1 is the standard character name which the character value in
 *  field 2 maps onto.  (It doesn't mean "to produce the character in field 1,
 *  use the value in field 2.)
 * 
 *  The character value may be given either as a single character (which will be
 *  converted to the ASCII value of the character), or in numeric format, either
 *  in decimal or 0xyy as hex yy.  Single or double quotes may be used to quote
 *  characters.
 *
 * http://perso.wanadoo.fr/blq
 * blq@wanadoo.fr
 */

typedef struct ansi_map_gen {
	char * token;		/* token du code hexa identifie */
	char * hexa;
} AnsiMapGen;

AnsiMapGen ansiMapG [] = {
/*  characters in ASCII range (00-127) */

	"formula",		"06",
	"nobrkhyphen",	"1e",
	"opthyphen",	"1f",

	"space",		" ",
	"exclam",		"!",
	"quotedbl",		"\"",
	"numbersign",	"#",
	"dollar",		"$",
	"percent",		"%",
	"ampersand",	"&",
	"quoteright",	"'",
	"parenleft",	"(",
	"parenright",	")",
	"asterisk",		"*",
	"plus",			"+",
	"comma",		",",
	"hyphen",		"-",
	"period",		".",
	"slash",		"/",
	"zero",			"0",
	"one",			"1",
	"two",			"2",
	"three",		"3",
	"four",			"4",
	"five",			"5",
	"six",			"6",
	"seven",		"7",
	"eight",		"8",
	"nine",			"9",
	"colon",		":",
	"semicolon",	";",
	"less",			"<",
	"equal",		"=",
	"greater",		">",
	"question",		"?",
	"at",			"@",
	"A",			"A",
	"B",			"B",
	"C",			"C",
	"D",			"D",
	"E",			"E",
	"F",			"F",
	"G",			"G",
	"H",			"H",
	"I",			"I",
	"J",			"J",
	"K",			"K",
	"L",			"L",
	"M",			"M",
	"N",			"N",
	"O",			"O",
	"P",			"P",
	"Q",			"Q",
	"R",			"R",
	"S",			"S",
	"T",			"T",
	"U",			"U",
	"V",			"V",
	"W",			"W",
	"X",			"X",
	"Y",			"Y",
	"Z",			"Z",
	"bracketleft",	"[",
	"backslash",	"\\",
	"bracketright",	"]",
	"asciicircum",	"^",
	"underscore",	"_",
	"quoteleft",	"\\`",
	"a",			"a",
	"b",			"b",
	"c",			"c",
	"d",			"d",
	"e",			"e",
	"f",			"f",
	"g",			"g",
	"h",			"h",
	"i",			"i",
	"j",			"j",
	"k",			"k",
	"l",			"l",
	"m",			"m",
	"n",			"n",
	"o",			"o",
	"p",			"p",
	"q",			"q",
	"r",			"r",
	"s",			"s",
	"t",			"t",
	"u",			"u",
	"v",			"v",
	"w",			"w",
	"x",			"x",
	"y",			"y",
	"z",			"z",
	"braceleft",	"{",
	"bar",			"|",
	"braceright",	"}",
	"asciitilde",	"~",

/*  non-ASCII characters (128-255) */

	"nobrkspace",		"a0",
	"exclamdown",		"a1",
	"cent",				"a2",
	"sterling",			"a3",
	"currency",			"a4",
	"yen",				"a5",
	"brokenbar",		"a6",
	"chapitre",			"a7",
	"dieresis",			"a8",
	"copyright",		"a9",
	"ordfeminine",		"aa",
	"guillemotleft",	"ab",
	"underscore",		"ac",
	"opthyphen",		"ad",
	"registered",		"ae",
	"macron",			"af",
	"degree",			"b0",
	"plusminus",		"b1",
	"twosuperior",		"b2",
	"threesuperior",	"b3",
	"acute",			"b4",
	"mu",				"b5",
	"paragraph",		"b6",
	"periodcentered",	"b7",
	"cedilla",			"b8",
	"onesuperior",		"b9",
	"ordmasculine",		"ba",
	"guillemotright",	"bb",
	"onequarter",		"bc",
	"onehalf",			"bd",
	"threequarters",	"be",
	"questiondown",		"bf",
	"Agrave",			"c0",
	"Aacute",			"c1",
	"Acircumflex",		"c2",
	"Atilde",			"c3",
	"Adieresis",		"c4",
	"Aring",			"c5",
	"AE",				"c6",
	"Ccedilla",			"c7",
	"Egrave",			"c8",
	"Eacute",			"c9",
	"Ecircumflex",		"ca",
	"Edieresis",		"cb",
	"Igrave",			"cc",
	"Iacute",			"cd",
	"Icircumflex",		"ce",
	"Idieresis",		"cf",
	"Eth",				"d0",
	"Ntilde",			"d1",
	"Ograve",			"d2",
	"Oacute",			"d3",
	"Ocircumflex",		"d4",
	"quoteright",		"d5",
	"Odieresis",		"d6",
	"multiply",			"d7",
	"Oslash",			"d8",
	"Ugrave",			"d9",
	"Uacute",			"da",
	"Ucircumflex",		"db",
	"Udieresis",		"dc",
	"Yacute",			"dd",
	"Thorn",			"de",
	"germandbls",		"df",
	"agrave",			"e0",
	"aacute",			"e1",
	"acircumflex",		"e2",
	"atilde",			"e3",
	"adieresis",		"e4",
	"aring",			"e5",
	"ae",				"e6",
	"ccedilla",			"e7",
	"egrave",			"e8",
	"eacute",			"e9",
	"ecircumflex",		"ea",
	"edieresis",		"eb",
	"igrave",			"ec",
	"iacute",			"ed",
	"icircumflex",		"ee",
	"idieresis",		"ef",
	"eth",				"f0",
	"ntilde",			"f1",
	"ograve",			"f2",
	"oacute",			"f3",
	"ocircumflex",		"f4",
	"otilde",			"f5",
	"odieresis",		"f6",
	"divide",			"f7",
	"oslash",			"f8",
	"ugrave",			"f9",
	"uacute",			"fa",
	"ucircumflex",		"fb",
	"udieresis",		"fc",
	"yacute",			"fd",
	"thorn",			"fe",
	"ydieresis",		"ff",

/*  non-ASCII characters double */
	"agrave",			"88",
	"egrave",			"8f",
	"eacute",			"8e",
	"ellipsis",		    "85",
	"trademark",	    "99",

	(char *)0,			(char *)0
};

