/* Output sequence map for rtftohtml
 *
 * Field 1 is the standard character name.  Field 2 is the output sequence
 * to produce for that character.
 *
 * The output sequence is simply a string of characters.  If it contains
 * whitespace, it may be quoted.  If it contains quotes, it may be quoted
 * with a different quote character.
 *
 * characters in ASCII range (32-127)
 *
 * http://perso.wanadoo.fr/blq
 * blq@wanadoo.fr
 */

typedef struct token_html_map {
	char * token;		/* token d'identification du tag HTML */
	char * tagHTML;
} TokenHTML;

TokenHTML tokenTag [] = {
	"space",		" ",
	"exclam",		"!",
	"quotedbl",		"\"",
	"numbersign",	"#",
	"dollar",		"$",
	"percent",		"%",
	"ampersand",	"&amp;",
	"quoteright",	"'",
	"parenleft",	"(",
	"parenright",	")",
	"asterisk",		"*",
	"plus",			"+",
	"comma",		",",
	"hyphen",		"-",
	"period",		".",
	"slash",		"/",
	"zero",			"0",
	"one",			"1",
	"two",			"2",
	"three",		"3",
	"four",			"4",
	"five",			"5",
	"six",			"6",
	"seven",		"7",
	"eight",		"8",
	"nine",			"9",
	"colon",		":",
	"semicolon",	";",
	"less",			"&lt;",
	"equal",		"=",
	"greater",		"&gt;",
	"question",		"?",
	"at",			"@",
	"A",			"A",
	"B",			"B",
	"C",			"C",
	"D",			"D",
	"E",			"E",
	"F",			"F",
	"G",			"G",
	"H",			"H",
	"I",			"I",
	"J",			"J",
	"K",			"K",
	"L",			"L",
	"M",			"M",
	"N",			"N",
	"O",			"O",
	"P",			"P",
	"Q",			"Q",
	"R",			"R",
	"S",			"S",
	"T",			"T",
	"U",			"U",
	"V",			"V",
	"W",			"W",
	"X",			"X",
	"Y",			"Y",
	"Z",			"Z",
	"bracketleft",	"[",
	"backslash",	"\\",
	"bracketright",	"]",
	"asciicircum",	"^",
	"underscore",	"_",
	"quoteleft",	"`",
	"a",			"a",
	"b",			"b",
	"c",			"c",
	"d",			"d",
	"e",			"e",
	"f",			"f",
	"g",			"g",
	"h",			"h",
	"i",			"i",
	"j",			"j",
	"k",			"k",
	"l",			"l",
	"m",			"m",
	"n",			"n",
	"o",			"o",
	"p",			"p",
	"q",			"q",
	"r",			"r",
	"s",			"s",
	"t",			"t",
	"u",			"u",
	"v",			"v",
	"w",			"w",
	"x",			"x",
	"y",			"y",
	"z",			"z",
	"braceleft",	"{",
	"bar",			"|",
	"braceright",	"}",
	"asciitilde",	"~",

/* non-ASCII */

	"OE",				"&OElig;",
	"alpha",			"a",
	"beta",				"b",
	"acute",			"'",
	"angleleft",		"[",
	"angleright",		"&gt;",
	"approxequal",		"~",
	"arrowboth",		"&lt;-&gt;",
	"arrowdblboth",		"&lt;=&gt;",
	"arrowdblleft",		"&lt;=",
	"arrowdblright",	"=&gt;",
	"arrowleft",		"&lt;-",
	"arrowright",		"-&gt;",
	"bullet",			"*",
	"cent",				"cents",
	"circumflex",		"^",
	"copyright",		"(c)",
	"copyrightsans",	"(c)",
	"dagger",			"+",
	"exclamdown",		"o",
	"degree",			"o",
	"delta",			"d",
	"divide",			"/",
	"dotlessi",			"i",
	"ellipsis",			"...",
	"emdash",			"--",
	"endash",			"-",
	"fi",				"fi",
	"fl",				"fl",
	"fraction",			"/",
	"grave",			"`",
	"greaterequal",		"&gt;=",
	"guillemotleft",	"&lt;&lt;",
	"guillemotright",	"&gt;&gt;",
	"guilsinglleft",	"&lt;",
	"guilsinglright",	"&gt;",
	"lessequal",		"&lt;=",
	"logicalnot",		"~",
	"mathasterisk",		"*",
	"mathdivise",		"/",
	"mathequal",		"=",
	"mathminus",		"-",
	"mathnumbersign",	"#",
	"mathplus",			"+",
	"mathtilde",		"~",
	"minus",			"-",
	"mu",				"u",
	"multiply",			"x",
	"nobrkhyphen",		"-",
	"nobrkspace",		"&nbsp;",
	"notequal",			"!=",
	"oe",				"oe",
	"onehalf",			"1/2",
	"onequarter",		"1/4",
	"periodcentered",	"<DD><LI>",
	"plusminus",		"+/-",
	"quotedblbase",		",,",
	"quotedblleft",		"\"",
	"quotedblright",	"\"",
	"quotesinglbase",	",",
	"registered",		"(R)",
	"registersans",		"(R)",
	"threequarters",	"3/4",
	"tilde",			"~",
	"trademark",		"(TM)",
	"AE",				"&AElig;",
	"Aacute",			"&Aacute;",
	"Acircumflex",		"&Acirc;",
	"Agrave",			"&Agrave;",
	"Aring",			"&Aring;",
	"Atilde",			"&Atilde;",
	"Adieresis",		"&Auml;",
	"Ccedilla",			"&Ccedil;",
	"ETH",				"&ETH;",
	"Eacute",			"&Eacute;",
	"Ecircumflex",		"&Ecirc;",
	"Egrave",			"&Egrave;",
	"Edieresis",		"&Euml;",
	"Iacute",			"&Iacute;",
	"Icircumflex",		"&Icirc;",
	"Igrave",			"&Igrave;",
	"Idieresis",		"&Iuml;",
	"Ntilde",			"&Ntilde;",
	"Oacute",			"&Oacute;",
	"Ocircumflex",		"&Ocirc;",
	"Ograve",			"&Ograve;",
	"Oslash",			"&Oslash;",
	"Otilde",			"&Otilde;",
	"Odieresis",		"&Ouml;",
	"THORN",			"&THORN;",
	"Uacute",			"&Uacute;",
	"Ucircumflex",		"&Ucirc;",
	"Ugrave",			"&Ugrave;",
	"Udieresis",		"&Uuml;",
	"Yacute",			"&Yacute;",
	"ae",				"&aelig;",
	"aacute",			"&aacute;",
	"acircumflex",		"&acirc;",
	"agrave",			"&agrave;",
	"aring",			"&aring;",
	"atilde",			"&atilde;",
	"adieresis",		"&auml;",
	"ccedilla",			"&ccedil;",
	"eacute",			"&eacute;",
	"ecircumflex",		"&ecirc;",
	"egrave",			"&egrave;",
	"eth",				"&eth;",
	"edieresis",		"&euml;",
	"iacute",			"&iacute;",
	"icircumflex",		"&icirc;",
	"igrave",			"&igrave;",
	"idieresis",		"&iuml;",
	"ntilde",			"&ntilde;",
	"oacute",			"&oacute;",
	"ocircumflex",		"&ocirc;",
	"ograve",			"&ograve;",
	"oslash",			"&oslash;",
	"otilde",			"&otilde;",
	"odieresis",		"&ouml;",
	"germandbls",		"&szlig;",
	"thorn",			"&thorn;",
	"uacute",			"&uacute;",
	"ucircumflex",		"&ucirc;",
	"ugrave",			"&ugrave;",
	"udieresis",		"&uuml;",
	"yacute",			"&yacute;",
	"ydieresis",		"&yuml;",

/* non-ASCII suite sans correspondance HTML */
	"chapitre",			"Chp.",
	"brokenbar",		"|",

	(char *)0,			(char *)0
};

